#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=Images\logo-128x128.ico
#AutoIt3Wrapper_Res_Comment=Codec-Lister V0.2
#AutoIt3Wrapper_Res_Description=Codec-Lister V0.2
#AutoIt3Wrapper_Res_Fileversion=0.2.0.4
#AutoIt3Wrapper_Res_Fileversion_AutoIncrement=y
#AutoIt3Wrapper_Res_ProductVersion=0.2.0
#AutoIt3Wrapper_Res_LegalCopyright=Lehmden 2020
#AutoIt3Wrapper_Res_Language=1031
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#Region ;Legal stuff
#comments-start

	Codec-Lister
	by Lehmden 2019

	Licence:
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.


	Dieses Programm ist Freie Software: Sie können es unter den Bedingungen
	der GNU General Public License, wie von der Free Software Foundation,
	Version 3 der Lizenz oder (nach Ihrer Wahl) jeder neueren
	veröffentlichten Version, weiterverbreiten und/oder modifizieren.

	Dieses Programm wird in der Hoffnung, dass es nützlich sein wird, aber
	OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
	Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
	Siehe die GNU General Public License für weitere Details.

	Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
	Programm erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.

#comments-end
#EndRegion ;Legal stuff

#Region ;Includes

#include <File.au3>

#include <GUIConstants.au3>

#EndRegion ;Includes

#Region ;Ini Read Config

Global $ini_inputfolder = IniRead(@ScriptDir & "\Codec-Lister.ini", "folder", "ini_inputfolder", @MyDocumentsDir)

Global $ini_language = IniRead(@ScriptDir & "\Codec-Lister.ini", "languages", "ini_language", "English")

#EndRegion ;Ini Read Config

#Region ;Ini Read Localized Strings

Global $lng_about = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_about", "About")

Global $lng_deutsch = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_deutsch", "Deutsch")

Global $lng_english = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_english", "English")

Global $lng_exit = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_exit", "Exit")

Global $lng_files = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_files", "File")

Global $lng_inputfoldertext = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_inputfoldertext", "Choose source directory (with videos to process)")

Global $lng_nofiles = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_nofiles", "No files found in Source Directory")

Global $lng_print = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_print", "Open in editor")

Global $lng_progress = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_progress", "Progress")

Global $lng_resolution = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_resolution", "Resolution")

Global $lng_search = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_search", "Search")

Global $lng_size = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_size", "Size (MB)")

Global $lng_start = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_start", "Start")

Global $lng_VideoCodec = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_VideoCodec", "List Video Codecs")

Global $lng_waiting = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_waiting", "Waiting")

Global $lng_working = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_working", "I am working on file no. :")

Global $lng_working2 = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_working2", " out of ")

Global $lng_workingon = IniRead(@ScriptDir & "\Language\" & $ini_language & ".lng", "Translation", "lng_workingon", "Working on:")

#EndRegion ;Ini Read Localized Strings

#Region ;Declare Global Variables

If @Compiled = 1 Then

	$Version = FileGetVersion(@ScriptFullPath)

Else

	$file = FileOpen(@ScriptFullPath, 0)

	If $file = -1 Then

		MsgBox(0, "Error", "Unable to open file.")

		Exit

	EndIf

	While 1

		Local $line = FileReadLine($file)

		If @error = -1 Then ExitLoop

		If StringInStr($line, "#AutoIt3Wrapper_Res_Fileversion=") Then

			$ver = StringSplit($line, "=")

			$Version = $ver[2]

			ExitLoop

		EndIf

	WEnd

	FileClose($file)

EndIf

Global $Clock = "00:00", $extstring, $WorkArray[0]

Global $Title = "Codec-Lister " & $Version

Global $tempdir = @ScriptDir & "\Temp"

Global $extype[0]

Global $CodecList[0][4]


#EndRegion ;Declare Global Variables

#Region ;Initial preparations

DirCreate($tempdir)

_ArrayAdd($extype, "mkv")
_ArrayAdd($extype, "mk3d")
_ArrayAdd($extype, "avi")
_ArrayAdd($extype, "mpg")
_ArrayAdd($extype, "mpeg")
_ArrayAdd($extype, "mov")
_ArrayAdd($extype, "divx")
_ArrayAdd($extype, "mp4")
_ArrayAdd($extype, "rm")
_ArrayAdd($extype, "ts")
_ArrayAdd($extype, "m2ts")
_ArrayAdd($extype, "flv")
_ArrayAdd($extype, "ogg")
_ArrayAdd($extype, "vob")
_ArrayAdd($extype, "asf")
_ArrayAdd($extype, "wmv")
_ArrayAdd($extype, "wtv")
_ArrayAdd($extype, "dvr-ms")

For $i = 0 To UBound($extype) - 1

	$extstring = $extstring & ";*." & $extype[$i]

Next

#EndRegion ;Initial preparations

#Region ;Main Window

#Region ;Generate Header And Footer

	$style = $WS_SYSMENU + $WS_CAPTION + $WS_MINIMIZEBOX; + $WS_EX_ACCEPTFILES + $BS_PUSHLIKE

	Global $Mainwindow = GUICreate($Title, 1000, 680, -1, -1, $style, $WS_EX_COMPOSITED)
	GUISetState(@SW_HIDE, $Mainwindow)

	GUISetBkColor("0xffffff")

	Global $Pic01 = GUICtrlCreatePic (@ScriptDir & "\Images\Codec-Lister_Header.jpg", 0, 0, 999, 111)

	Global $Pic02 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_1.jpg", 0, 111, 1000, 1)

	Global $Label01 = GUICtrlCreateLabel($Title, 1, 632, 999, 28, $SS_ETCHEDFRAME)

	Global $Label02 = GUICtrlCreateLabel($lng_waiting, 10, 639, 900, 18)

	Global $Label03 = GUICtrlCreateLabel($Clock, 935, 639, 50, 18, $SS_RIGHT)

	Dim $Array_GUI_Elements_[1]
	_ArrayAdd($Array_GUI_Elements_, $Label01)
	_ArrayAdd($Array_GUI_Elements_, $Label02)
	_ArrayAdd($Array_GUI_Elements_, $Label03)
	_ArrayAdd($Array_GUI_Elements_, $Pic01)
	_ArrayAdd($Array_GUI_Elements_, $Pic02)

#EndRegion

#Region ;Generate Main Menu

	Global $Filemenu = GUICtrlCreateMenu($lng_files)

	Global $Englishitem = GUICtrlCreateMenuItem($lng_english, $filemenu, -1, 1)
	Global $Deutschitem = GUICtrlCreateMenuItem($lng_deutsch, $filemenu, -1, 1)
	Global $Separatoritem = GUICtrlCreateMenuItem("", $filemenu)
	Global $Exititem = GUICtrlCreateMenuItem($lng_exit, $filemenu)

	If $ini_language = "English" Then GUICtrlSetState($Englishitem, $GUI_CHECKED)
	If $ini_language = "Deutsch" Then GUICtrlSetState($Deutschitem, $GUI_CHECKED)


#EndRegion

#Region ;Generate Help Menu

	Global $Helpmenu = GUICtrlCreateMenu("?")
	Global $Infoitem = GUICtrlCreateMenuItem($lng_about, $helpmenu)

#EndRegion

#Region ;Generate Process GUI (1-1)

	Global $label_01_01 = GUICtrlCreateLabel($lng_VideoCodec, 20, 130, 800, 50)
	GUICtrlSetFont(-1, 20, 700, 0, "Georgia")

	Global $button_01_02 = GUICtrlCreateButton($lng_search, 460, 207, 60)

	Global $label_01_02 = GUICtrlCreateLabel($lng_inputfoldertext, 50, 180, 400, 20)

	Global $input_01_01 = GUICtrlCreateInput($ini_inputfolder, 50, 210, 400, 20)

	Global $button_01_01 = GUICtrlCreateButton($lng_start, 900, 207, 90)
	GUICtrlSetState(-1, $GUI_DEFBUTTON)

	Global $button_01_03 = GUICtrlCreateButton($lng_print, 900, 157, 90)
	GUICtrlSetState($button_01_03, $GUI_HIDE)

	Global $Pic_01_01 = GUICtrlCreatePic (@ScriptDir & "\Images\Line_1.jpg", 1, 249, 998, 1)

	Global $label_01_03 = GUICtrlCreateLabel("Index", 20, 270, 25, 20)

	Global $label_01_04 = GUICtrlCreateLabel("Codec", 70, 270, 30, 20)

	Global $label_01_05 = GUICtrlCreateLabel($lng_resolution, 169, 270, 50, 20)

	Global $label_01_06 = GUICtrlCreateLabel($lng_size, 260, 270, 70, 20)

	Global $label_01_07 = GUICtrlCreateLabel($lng_files, 355, 270, 50, 20)

	Global $List_01_01 = GUICtrlCreateList("", 20, 290, 967, 330, BitOR($LBS_DISABLENOSCROLL, $WS_BORDER, $WS_VSCROLL, $LBS_STANDARD, $LBS_USETABSTOPS), $ES_READONLY)

#EndRegion

#EndRegion

#Region ;Progress Windows

	$style = $WS_SYSMENU + $WS_CAPTION + $WS_MAXIMIZEBOX + $WS_MINIMIZEBOX + $BS_PUSHLIKE

	Global $Progresswindow = GUICreate("Codec-Lister - " & $lng_progress, 500, 314, -1, -1, $style, $WS_EX_TOPMOST + $WS_EX_COMPOSITED)
	GUISetState(@SW_HIDE, $Progresswindow)

	GUISetBkColor("0xffffff")

	Global $PR_Pic01 = GUICtrlCreatePic (@ScriptDir & "\Images\logo-big.bmp", 0, 0, 164, 314)

	Global $PR_label_01 = GUICtrlCreateLabel($lng_workingon, 180, 20, 290, 40, $SS_CENTER)
	GUICtrlSetFont(-1, 20, 0, 0, "Verdana")

	Global $PR_label_02 = GUICtrlCreateLabel("", 180, 70, 290, 40, $SS_CENTER)
	GUICtrlSetFont(-1, 12, 0, 0, "Verdana")

	Global $PR_label_03 = GUICtrlCreateLabel("", 170, 130, 310, 30, $SS_CENTER)
	GUICtrlSetFont(-1, 10, 0, 0, "Verdana")

	Global $PR_label_04 = GUICtrlCreateLabel("", 170, 170, 310, 30, $SS_CENTER)
	GUICtrlSetFont(-1, 10, 0, 0, "Verdana")

	Global $progressbar_PR_01_01 = GUICtrlCreateProgress(180, 220, 303, 20)


#EndRegion

#Region ;Show Main Windows

GUISetState(@SW_SHOW, $Mainwindow)

_GUI_Main()

#EndRegion ;Show Main Windows

#Region ;Function declaration

;Function Exit
Func _Exit()

	_SaveSettings()

	Exit

EndFunc   ;==>_Exit

;Function to read recent Time
Func _GetTime()

	Local $newtime = @HOUR & ":" & @MIN

	If $newtime = $Clock Then

		Return

	Else

		$Clock = $newtime

		GUICtrlSetData($Label03, $newtime)

		Return

	EndIf

EndFunc ;Get Time

;Function to list files and codecs
Func _List($InDir)

	Local $i, $split, $sDrive, $sDir, $sFilename, $sExtension, $resolution, $wIndex, $hIndex, $fIndex, $string

	Local $jhandle, $jfile, $MediaInfo, $vIndex, $sIndex, $width, $height, $size, $size1, $format, $format1, $step, $p

	$WorkArray = _FileListToArrayRec($InDir, $extstring, 1, 1, 1)

	GUICtrlSetData($list_01_01, "")

	If Not IsArray($WorkArray) Then

		MsgBox(0, "", $lng_nofiles)

		Return

	EndIf

	GUISetState(@SW_SHOW, $Progresswindow)

	Dim $CodecList[0][4]

	For $i = 1 to $WorkArray[0]

		$string = $i

		_SetData($Label02, $lng_working & $i & " " & $lng_working2  & " " & $WorkArray[0])

		$file = $InDir & "\" & $WorkArray[$i]

		$split = _PathSplit($file, $sDrive, $sDir, $sFilename, $sExtension)

		_SetData($PR_label_02, $split[3])

		_SetData($PR_label_03, $lng_working)

				While StringLen($string) < 5

			$string = " " & $string

		Wend

		_SetData($PR_label_04, $string & " " & $lng_working2 & " " & $WorkArray[0])

		$step = 100 /$WorkArray[0]

		$p = ($step * $i)

		_SetData($progressbar_PR_01_01, $p)

		RunWait(@ComSpec & ' /c mediainfo.exe --Full "' & $file & '" > "' & $tempdir & '\mediainfo.txt"', @ScriptDir, @SW_HIDE, $STDERR_CHILD + $STDOUT_CHILD)

		$jhandle = FileOpen($tempdir & '\mediainfo.txt')

		$jfile = FileRead($jhandle)

		FileClose($jhandle)

		$MediaInfo = StringSplit($jfile, @CRLF, $STR_ENTIRESPLIT)

		$vIndex = _ArraySearch($MediaInfo, "Kind of stream                           : Video", 0, 0, 0, 1)

		$aIndex = _ArraySearch($MediaInfo, "Audio #1", 0, 0, 0, 0)

		If @error Then $aIndex = _ArraySearch($MediaInfo, "Audio    ", 0, 0, 0, 1)

		;Get width of video
		$wIndex = _ArraySearch($MediaInfo, "Width", $vIndex, 0, 0, 1)

		If @error Then

			$width = ""

		Else

			$width = StringRegExpReplace($MediaInfo[$wIndex], "[^0-9]", "")

		EndIf

		;Get height of video
		$hIndex = _ArraySearch($MediaInfo, "Height", $vIndex, 0, 0, 1)

		If @error Then

			$height = ""

		Else

			$height = StringRegExpReplace($MediaInfo[$hIndex], "[^0-9]", "")

		EndIf

		;Get Codec of video
		$fIndex = _ArraySearch($MediaInfo, "Format", $vIndex, 0, 0, 1)

		If @error Then

			$format = ""

		Else

			$format1 = StringSplit($MediaInfo[$fIndex], ": ", 1)

			$format = StringStripWS($format1[2], 3)

		EndIf

		While StringLen($format) < 15

			$format = $format & " "

		Wend

		;Get size of video
		$sIndex = _ArraySearch($MediaInfo, "File size  ", 0, 0, 0, 1)

		If @error Then

			$size = ""

		Else

			$size1 = StringSplit($MediaInfo[$sIndex], ": ", 1)

			$size = StringFormat("%.1f", Int($size1[2]) / 1048576)

		EndIf

		While StringLen($size) < 8

			$size = $size & " "

		Wend

		GUICtrlSetData($list_01_01, StringFormat("%06i", $i) & ": " & @TAB & $format & @TAB & $width & "  x " & $height & @TAB & $size & @TAB & @TAB & $file)

		$resolution = $width & " x " & $height

		While StringLen($resolution) < 15

			$resolution = $resolution & " "

		Wend

		_ArrayAdd($CodecList, $format & "|" & $resolution & "|" & $size & "|" & $file, 0, "|")

	Next

	GUICtrlSetState($button_01_03, $GUI_SHOW)

	_SetData($progressbar_PR_01_01, 0)

	GUISetState(@SW_HIDE, $Progresswindow)

	_SetData($Label02, $lng_waiting)


EndFunc

;Function to print files and codecs
Func _Print()

	Local $file

	$file = FileOpen($tempdir & '\print.txt', 2)

	FileWrite($file, "Codec" & @TAB & @TAB & @TAB  & $lng_resolution & @TAB & @TAB & $lng_size & @TAB & @TAB & $lng_files & @CRLF & @CRLF)

	For $i = 0 to UBound($CodecList) - 1

		FileWrite($file, $CodecList[$i][0] & @TAB & $CodecList[$i][1] & @TAB & $CodecList[$i][2] & @TAB & @TAB & $CodecList[$i][3] & @CRLF)

	Next

	FileClose($file)

	ShellExecute($tempdir & '\print.txt')

EndFunc

;Function to Save Settings in INI files.
Func _SaveSettings()

	IniWrite(@ScriptDir & "\Codec-Lister.ini", "folder", "ini_inputfolder", GUICtrlRead($input_01_01))

	If BitAND(GUICtrlRead($Englishitem), $GUI_CHECKED) = $GUI_CHECKED Then

		IniWrite(@ScriptDir & "\Codec-Lister.ini", "languages", "ini_language", "English")

	EndIf

	If BitAND(GUICtrlRead($Deutschitem), $GUI_CHECKED) = $GUI_CHECKED Then

		IniWrite(@ScriptDir & "\Codec-Lister.ini", "languages", "ini_language", "Deutsch")

	EndIf

EndFunc

;Function to Update controls.
Func _SetData($cControl, $sData)

	If GUICtrlRead($cControl) <> $sData Then GUICtrlSetData($cControl, $sData)

EndFunc

#EndRegion

#Region ;GUI Loop

;Function to Create Main GUI
Func _GUI_Main()

	While 1

		_GetTime()

		Local $msg1 = GUIGetMsg(1)

		Select

			Case $msg1[0] = $infoitem

				MsgBox(0, $lng_about & " " & $Title, "Codec-Lister" & @CRLF & @CRLF & "(C) 2019 Lehmden" & @CRLF & @CRLF & "Version: " & $version)


			Case $msg1[0] = $button_01_02

				$IF1 = GUICtrlRead($input_01_01)

				$inputfolder = FileSelectFolder($lng_inputfoldertext, $IF1, -1, $IF1)

				If $inputfolder <> "" Then

					IniWrite(@ScriptDir & "\Codec-Lister.ini", "folder", "ini_inputfolder", $inputfolder)

					_SetData($input_01_01, $inputfolder)

					GUICtrlSetState($button_01_03, $GUI_HIDE)

				EndIf


			Case $msg1[0] = $button_01_01

				_List(GUICtrlRead($input_01_01))


			Case $msg1[0] = $button_01_03

				_Print()

			Case $msg1[0] = $GUI_EVENT_CLOSE Or $msg1[0] = $Exititem

				_Exit()


		EndSelect

		Sleep(20)

	WEnd

EndFunc
#EndRegion ;GUI Functions

;End of Program

